use strict;

# usage: prove long_lines.t

use Test::More;
use File::Find;
use File::Slurp;
use FindBin qw/$Bin/;

my $TOO_LONG_LINE = 100;
my $ROOT = "$Bin/files"; 

my %SKIP = map { $ROOT."/".$_ => 1 } qw!  
html/bukvy.html
html/bukvy_files/addthis_widget.js
html/bukvy_files/all.js
html/bukvy_files/all_002.js
html/bukvy_files/auth014.js
html/bukvy_files/client.js
html/bukvy_files/core086.js
html/bukvy_files/counter016.js
html/bukvy_files/ga.js
html/bukvy_files/hub.html
html/bukvy_files/hub_002.html
html/bukvy_files/like.html
html/bukvy_files/ping.html
html/bukvy_files/sh126.html
html/bukvy_files/tweet_button.html
html/bukvy_files/watch.js
html/bukvy_files/widgets.js
html/bukvy_files/xd_arbiter.html
html/bukvy_files/xd_arbiter_002.html,
!;

my @files_to_check;
find(
    sub {
        if (/\.(html|js|pm|pl)$/ && -f $File::Find::name) {
            return if $SKIP{$File::Find::name};
            push @files_to_check, $File::Find::name;
        }
    },
    $ROOT
);

Test::More::plan(tests => scalar(@files_to_check));

for my $file (@files_to_check){
    my $text = read_file($file, binmode => ':utf8');
    ok($text !~ /[^\n]{$TOO_LONG_LINE,}/, "file $file contains too long lines")
}
